static const char file_id[] = "DEControlFIFO.pl";
// .cc file generated from DEControlFIFO.pl by ptlang
/*
 * copyright (c) SEE $PTOLEMY_SIMULATIONS/TCP/copyright
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEControlFIFO.h"
#include "DataStruct.h"

const char *star_nm_DEControlFIFO = "DEControlFIFO";

const char* DEControlFIFO :: className() const {return star_nm_DEControlFIFO;}

ISA_FUNC(DEControlFIFO,DEStar);

Block* DEControlFIFO :: makeNew() const { LOG_NEW; return new DEControlFIFO;}

DEControlFIFO::DEControlFIFO ()
{
	setDescriptor("This star simulates the buffer of the application.");
	addPort(demand.setPort("demand",this,FLOAT));
	addPort(inData.setPort("inData",this,ANYTYPE));
	addPort(outData.setPort("outData",this,ANYTYPE));
	outData.inheritTypeFrom(inData);
	addPort(size.setPort("size",this,INT));
	addPort(overflow.setPort("overflow",this,ANYTYPE));
	overflow.inheritTypeFrom(inData);
	addState(capacity.setState("capacity",this,"-1","Maximum size of the queue. If <0, capacity is infinite."));

# line 48 "DEControlFIFO.pl"
// Indicate to the scheduler that size outputs are triggered
		// demand inputs.
		// simultaneous inData events should be available in the
		// same firing with demand events
         	   demand.before(inData);
}

DEControlFIFO::~DEControlFIFO() {
# line 172 "DEControlFIFO.pl"
zapQueue();
}

void DEControlFIFO::setup() {
# line 55 "DEControlFIFO.pl"
infinite = (int(capacity) < 0);
		control=1;
		First=1;
		zapQueue();
}

void DEControlFIFO::go() {
# line 123 "DEControlFIFO.pl"
completionTime = arrivalTime;

//****************************************************************************
// The application finished consuming a packet an can take another one
//****************************************************************************

	    if (demand.dataNew)
	    {
	      demand.dataNew= FALSE;
	      size.put(completionTime)<<Qsize(); // update the window size
       	      if(Qsize())
	      {
	
		  Particle* pp = (Particle*) dequeue();
		  outData.put(completionTime) = *pp;
		  pp->die();
		  control=0; // application is busy
	      }
	      else
	          control=1;
	    }

//*************************************************************************
// If there is new inData, store it if the application is busy
//*************************************************************************

	    if (inData.dataNew)
	    {
	      inData.dataNew=FALSE;
	      if(!Qsize()&&control)
	      {
	        if(First>0)
	        {
	           First=0;
		   size.put(completionTime)<<1;
		}
		outData.put(completionTime) =inData%0;
	        control=0;
	      }
	      else
	      {
		enqueue();
	        //size.put(completionTime)<<Qsize();
	      }
	    }
}


void DEControlFIFO::enqueue ()
{
# line 73 "DEControlFIFO.pl"
if (infinite || Qsize() < int(capacity)) {
			queue.put(inData.get().clone());
		    } else {
			// Data is lost
			overflow.put(completionTime) = inData.get();
		    }
}


Pointer DEControlFIFO::dequeue ()
{
# line 87 "DEControlFIFO.pl"
return queue.get();
}


void DEControlFIFO::handleOverflow ()
{
# line 96 "DEControlFIFO.pl"
// Nothing to do
}


int DEControlFIFO::Qsize ()
{
# line 105 "DEControlFIFO.pl"
return queue.length();
}


void DEControlFIFO::zapQueue ()
{
# line 111 "DEControlFIFO.pl"
while (Qsize() > 0) {
				Particle* pp = (Particle*) queue.get();
				pp->die();
			}
			queue.initialize();
}


// prototype instance for known block list
static DEControlFIFO proto;
static RegisterBlock registerBlock(proto,"ControlFIFO");
