static const char file_id[] = "DEEPRCA_Receive.pl";
// .cc file generated from DEEPRCA_Receive.pl by ptlang
/*
 * copyright (c) SEE $PTOLEMY_SIMULATIONS/copyright
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEEPRCA_Receive.h"

const char *star_nm_DEEPRCA_Receive = "DEEPRCA_Receive";

const char* DEEPRCA_Receive :: className() const {return star_nm_DEEPRCA_Receive;}

ISA_FUNC(DEEPRCA_Receive,DEStar);

Block* DEEPRCA_Receive :: makeNew() const { LOG_NEW; return new DEEPRCA_Receive;}

DEEPRCA_Receive::DEEPRCA_Receive ()
{
	setDescriptor("");
	addPort(Receive.setPort("Receive",this,MESSAGE));
	addPort(Answer.setPort("Answer",this,MESSAGE));
	addState(fileName.setState("fileName",this,"<stdout>","Filename for output"));
	addState(debug.setState("debug",this,"0","debug"));

# line 63 "DEEPRCA_Receive.pl"
p_out = 0;
}

void DEEPRCA_Receive::wrapup() {
# line 66 "DEEPRCA_Receive.pl"
LOG_DEL; delete p_out;
		p_out = 0;
}

void DEEPRCA_Receive::begin() {
# line 54 "DEEPRCA_Receive.pl"
LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
}

DEEPRCA_Receive::~DEEPRCA_Receive() {
# line 69 "DEEPRCA_Receive.pl"
LOG_DEL; delete p_out;
}

void DEEPRCA_Receive::setup() {
# line 48 "DEEPRCA_Receive.pl"
}

void DEEPRCA_Receive::go() {
# line 72 "DEEPRCA_Receive.pl"
pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
		Envelope Envp;
                Receive.get().getMessage(Envp);
                const ATMCell *cellPtr =( const ATMCell *)
                    Envp.myData();
		if(cellPtr->readRM()==0)
	        { 
			VC_CI=cellPtr->readEFCI();
if(debug)
OUTPUT<<" DEST norm "<<cellPtr->readDestination()<<" VC_CI "<<VC_CI<<" at "<<completionTime<<"\n";
		}
		else
		{
if(debug) OUTPUT<<" RM "<<cellPtr->readRM()<<" VC_CI "<<VC_CI <<" CI "<<cellPtr->readCI()<<"\n";
                        LOG_NEW;
                        ATMCell* RM_Cell = new ATMCell(0);
                        RM_Cell->setRM(1);
                        RM_Cell->setSource(cellPtr->readSource());
                        RM_Cell->setDestination(cellPtr->readDestination());
                        RM_Cell->setVC(cellPtr->readVC());
                        RM_Cell->setDIR(0);
                        RM_Cell->setACR(cellPtr->readACR());
                        RM_Cell->setER(cellPtr->readER());
			if(VC_CI)
                           RM_Cell->setCI(VC_CI);
			else
                           RM_Cell->setCI(cellPtr->readCI());           
                        Envelope envp( *RM_Cell);
if(debug)
OUTPUT<<"Send CI "<<RM_Cell->readCI()<<"\n";
                        Answer.put(completionTime)<<envp;
		}
}

// prototype instance for known block list
static DEEPRCA_Receive proto;
static RegisterBlock registerBlock(proto,"EPRCA_Receive");
