 defstar {
 	name {EPRCA_Receive }
	domain { DE }
	author { Dorgham Sisalem}
        copyright { SEE $PTOLEMY_SIMULATIONS/copyright }

	desc {
	}

	input { name { Receive}
                type { message}
	        desc { incoming cells}
	}

	output { name { Answer}
                 type { message}
	         desc { return messages}
        }


	hinclude { "ATMCell.h" ,<math.h>}

	defstate {
		name { fileName }
		type { string }
		default { "<stdout>" }
		desc { Filename for output }
	}
	defstate {
		name { debug}
		type { int }
		default {0 }
	}
	hinclude { "pt_fstream.h" }
	protected {
		pt_ofstream *p_out;
	}

	protected { 
	           int VC_CI;
		  }

//*****************************************************************************/
// initialization: 
//*****************************************************************************/

	setup { 
              }

//*****************************************************************************/
//*****************************************************************************/

	begin  {  
                LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
		}

//****************************************************************************/
// set scheduling priorities
//****************************************************************************/

	constructor { 
                      p_out = 0;
               	    }
        wrapup {
	        LOG_DEL; delete p_out;
		p_out = 0;
		}
	destructor { LOG_DEL; delete p_out;}

	go {
                pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
		Envelope Envp;
                Receive.get().getMessage(Envp);
                const ATMCell *cellPtr =( const ATMCell *)
                    Envp.myData();
		if(cellPtr->readRM()==0)
	        { 
			VC_CI=cellPtr->readEFCI();
if(debug)
OUTPUT<<" DEST norm "<<cellPtr->readDestination()<<" VC_CI "<<VC_CI<<" at "<<completionTime<<"\n";
		}
		else
		{
if(debug) OUTPUT<<" RM "<<cellPtr->readRM()<<" VC_CI "<<VC_CI <<" CI "<<cellPtr->readCI()<<"\n";
                        LOG_NEW;
                        ATMCell* RM_Cell = new ATMCell(0);
                        RM_Cell->setRM(1);
                        RM_Cell->setSource(cellPtr->readSource());
                        RM_Cell->setDestination(cellPtr->readDestination());
                        RM_Cell->setVC(cellPtr->readVC());
                        RM_Cell->setDIR(0);
                        RM_Cell->setACR(cellPtr->readACR());
                        RM_Cell->setER(cellPtr->readER());
			if(VC_CI)
                           RM_Cell->setCI(VC_CI);
			else
                           RM_Cell->setCI(cellPtr->readCI());           
                        Envelope envp( *RM_Cell);
if(debug)
OUTPUT<<"Send CI "<<RM_Cell->readCI()<<"\n";
                        Answer.put(completionTime)<<envp;
		} 

	   } // end go
} // end defstar
