static const char file_id[] = "DEEPRCA_Send.pl";
// .cc file generated from DEEPRCA_Send.pl by ptlang
/*
 * copyright (c) SEE $PTOLEMY_SIMULATIONS/copyright
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEEPRCA_Send.h"

const char *star_nm_DEEPRCA_Send = "DEEPRCA_Send";

const char* DEEPRCA_Send :: className() const {return star_nm_DEEPRCA_Send;}

ISA_FUNC(DEEPRCA_Send,DEStar);

Block* DEEPRCA_Send :: makeNew() const { LOG_NEW; return new DEEPRCA_Send;}

DEEPRCA_Send::DEEPRCA_Send ()
{
	setDescriptor("ABR source as was specified in ATM-Forum 94-0735R2");
	addPort(RM.setPort("RM",this,MESSAGE));
	addPort(Cell.setPort("Cell",this,MESSAGE));
	addPort(Size.setPort("Size",this,INT));
	addPort(S_Cell.setPort("S_Cell",this,MESSAGE));
	addPort(demand.setPort("demand",this,FLOAT));
	addState(ICR.setState("ICR",this,"18278","Initial Cell Rate"));
	addState(AIR.setState("AIR",this,"125","Additive Increase Rate"));
	addState(PCR.setState("PCR",this,"365566","Peak Cell Rate"));
	addState(Nrm.setState("Nrm",this,"32","RM Cell interval"));
	addState(MCR.setState("MCR",this,"3655.7","Minimum Cell Rate"));
	addState(MDF.setState("MDF",this,"8","Multiplicative Decrease Factor"));
	addState(Mrm.setState("Mrm",this,"2","Mrm"));
	addState(TOF.setState("TOF",this,"2","TOF"));
	addState(Trm.setState("Trm",this,"0.100","Trm"));
	addState(source.setState("source",this,"0","source address"));
	addState(destination.setState("destination",this,"0","destination address"));
	addState(VC.setState("VC",this,"0","VC number"));
	addState(debug.setState("debug",this,"0",""));
	addState(fileName.setState("fileName",this,"<stdout>","Filename for output"));

# line 159 "DEEPRCA_Send.pl"
p_out = 0;
		      Size.before(Cell);
		      Size.before(RM);
		      RM.before(Cell);
}

void DEEPRCA_Send::wrapup() {
# line 165 "DEEPRCA_Send.pl"
LOG_DEL; delete p_out;
		p_out = 0;
}

void DEEPRCA_Send::begin() {
# line 150 "DEEPRCA_Send.pl"
LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
}

DEEPRCA_Send::~DEEPRCA_Send() {
# line 168 "DEEPRCA_Send.pl"
LOG_DEL; delete p_out;
}

void DEEPRCA_Send::setup() {
# line 135 "DEEPRCA_Send.pl"
last_RM=0;
	        ACR=ICR;
	        count=0;
	        cell_sent=0;
	        mdf=pow(2,MDF);
        	ADR=ACR/mdf;
	        next_cell_time=0;
		queue=1;
		flag=1;
}

void DEEPRCA_Send::go() {
# line 171 "DEEPRCA_Send.pl"
pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
//****************************************************************************/
	        if(Size.dataNew)
	        {
		   queue=Size.get();
//if(debug)
//OUTPUT<<" SIZE "<<queue<<" ACR "<<ACR<<" at "<<completionTime<<" \n";
	           if((ACR>ICR)||cell_sent)
	           {
	                //ACR=max(ACR-ADR,MCR);
	                ACR=max((float)ACR,(float)MCR);
//OUTPUT<<" ACR "<<ACR;
		   }
	           if(queue)
	           { 
			cell_sent=1;
		   }
	           else
	                cell_sent=0;
	           if((count+1)%Nrm==0)
		     next_cell_time+= (float) 2/ACR; //Schedule Cell
		   else
		     next_cell_time+= (float) 1/ACR; //Schedule Cell

	             demand.put(completionTime)<<(float) 1/ACR;
//OUTPUT<<" next "<<next_cell_time<<" \n";
	        }
//****************************************************************************
	        if(Cell.dataNew)
	        {
		   Envelope Envp;
                   Cell.get().getMessage(Envp);
                   ATMCell *cellPtr =(ATMCell *)
                    Envp.myData();
		   int seq=cellPtr->readSeq();
		   S_Cell.put(completionTime)<<Envp;
       	                if(((count++)%Nrm==0)||((count)%Nrm>Mrm&&(completionTime>=Trm+last_RM)))
		        {
if(debug)OUTPUT<<" count "<<count<<" NRM "<<Nrm<<" at "<<completionTime<<"\n";
	                 last_RM=completionTime;
			 LOG_NEW;
       			 ATMCell* RM_Cell = new ATMCell(0);
		         RM_Cell->setRM(1);
 			 RM_Cell->setSource(source);
			 RM_Cell->setDestination(destination);
			 RM_Cell->setVC(VC);
			 RM_Cell->setDIR(1);
			 RM_Cell->setACR(ACR);
			 RM_Cell->setER(PCR);
			 RM_Cell->setCI(0);	
			 Envelope envp( *RM_Cell);
			 S_Cell.put(completionTime)<<envp;
		        }
	       }
//****************************************************************************/
	      if(RM.dataNew)
	      {
		Envelope Envp;
                RM.get().getMessage(Envp);
                ATMCell* cellPtr =(ATMCell *)
                    Envp.myData();
		float ER;
		ER=cellPtr->readER();
		int CI=cellPtr->readCI();
if(debug)
{OUTPUT<<" RM "<<ER<<" DEST "<<cellPtr->readDestination()<<" VC "<<cellPtr->readVC()<<" at "<<completionTime<<"\n";
OUTPUT<<"\n CI "<<CI<<"  ER "<<ER<<" ADR "<<ADR<<" AIR "<<AIR<<"\n";}
		if(CI==0)
	        {
if(debug)
OUTPUT<<" DO MD "<<ACR<<" Nrm* "<<AIR;
			ACR+=(float)Nrm*(float)AIR;
if(debug)
OUTPUT<<" ACR "<<ACR<<"\n";
			ACR=min((float)ACR,(float)PCR);
if(debug)
OUTPUT<<" ACR,PCR "<<ACR<<" PCR "<<PCR;
		}
		else
		{
if(debug)
OUTPUT<<" DO AI "<<ACR<<" = "<<ACR<<" / "<<MDF;
	                ACR-=(float)Nrm*(float)((float)ACR/(float)mdf);
if(debug)
OUTPUT<<" ACR "<<ACR<<"\n";
		}		
		ACR=min((float)ACR,(float)ER);
		ACR=max((float)ACR,(float)MCR);
if(debug)
OUTPUT<<" ACRFinal= "<<ACR<<" at "<<completionTime<<"\n";
 	
              }
}

// prototype instance for known block list
static DEEPRCA_Send proto;
static RegisterBlock registerBlock(proto,"EPRCA_Send");
