defstar {
 	name { EPRCA_Send}
	domain { DE }
	author { Dorgham Sisalem}
        copyright { SEE $PTOLEMY_SIMULATIONS/copyright }

	desc { ABR source as was specified in ATM-Forum 94-0735R2
	}

	input { name {RM }
                type { message}
	        desc { Resource Management Cells}
	}
	input { name { Cell}
                type { message}
	        desc { Messages to send}
	}
	input { name { Size}
                type { int}
	        desc { Size of the queue}
	}

	output { name { S_Cell}
                 type { message}
	         desc { send a message}
        }
	output { name { demand}
                 type { float}
	         desc { Fetch a message from the queue}
        }

	defstate {
		name { ICR}
		type { float}
		default { 18278}
		desc { Initial Cell Rate}
	}
	defstate {
		name { AIR}
		type { float}
		default { 125}
		desc { Additive Increase Rate}
	}
	defstate {
		name { PCR}
		type { float}
		default { 365566}
		desc { Peak Cell Rate}
	}
	defstate {
		name { Nrm}
		type { int}
		default {32 }
		desc { RM Cell interval}
	}
	defstate {
		name { MCR}
		type { float}
		default { 3655.7}
		desc { Minimum Cell Rate}
	}
	defstate {
		name { MDF}
		type { float}
		default {8 }
		desc { Multiplicative Decrease Factor}
	}
	defstate {
		name { Mrm}
		type { int}
		default {2 }
	}
	defstate {
		name { TOF}
		type { int}
		default {2 }
	}
	defstate {
		name { Trm}
		type { float}
		default {0.100 }
	}
	defstate {
		name { source}
		type { int}
		default {0 }
		desc { source address}
	}
	defstate {
		name { destination}
		type { int}
		default {0 }
		desc { destination address}
	}

	defstate {
		name { VC}
		type { int}
		default {0 }
		desc { VC number}
	}
	defstate {
		name { debug}
		type { int}
		default {0 }
		desc { }
	}
	defstate {
		name { fileName }
		type { string }
		default { "<stdout>" }
		desc { Filename for output }
	}
	hinclude { "pt_fstream.h" ,<math.h>,"ATMCell.h",<minmax.h>}
	protected {
		pt_ofstream *p_out;
	}

	protected {
	            float ACR;
		    int count;
	            int cell_sent;
	            double mdf,ADR,last_RM;
	            double next_cell_time;
		    int queue;
		    float TDF;
		    int flag;
		  }

//*****************************************************************************/
// initialization: 
//*****************************************************************************/

	setup { 
                last_RM=0;
	        ACR=ICR;
	        count=0;
	        cell_sent=0;
	        mdf=pow(2,MDF);
        	ADR=ACR/mdf;
	        next_cell_time=0;
		queue=1;
		flag=1;
              }

//*****************************************************************************/
//*****************************************************************************/

	begin  {  
                LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
		}

//****************************************************************************/
// set scheduling priorities
//****************************************************************************/

	constructor { 
                      p_out = 0;
		      Size.before(Cell);
		      Size.before(RM);
		      RM.before(Cell);
               	    }
        wrapup {
	        LOG_DEL; delete p_out;
		p_out = 0;
		}
	destructor { LOG_DEL; delete p_out;}

	go {
                pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
//****************************************************************************/
	        if(Size.dataNew)
	        {
		   queue=Size.get();
//if(debug)
//OUTPUT<<" SIZE "<<queue<<" ACR "<<ACR<<" at "<<completionTime<<" \n";
	           if((ACR>ICR)||cell_sent)
	           {
	                //ACR=max(ACR-ADR,MCR);
	                ACR=max((float)ACR,(float)MCR);
//OUTPUT<<" ACR "<<ACR;
		   }
	           if(queue)
	           { 
			cell_sent=1;
		   }
	           else
	                cell_sent=0;
	           if((count+1)%Nrm==0)
		     next_cell_time+= (float) 2/ACR; //Schedule Cell
		   else
		     next_cell_time+= (float) 1/ACR; //Schedule Cell

	             demand.put(completionTime)<<(float) 1/ACR;
//OUTPUT<<" next "<<next_cell_time<<" \n";
	        }
//****************************************************************************
	        if(Cell.dataNew)
	        {
		   Envelope Envp;
                   Cell.get().getMessage(Envp);
                   ATMCell *cellPtr =(ATMCell *)
                    Envp.myData();
		   int seq=cellPtr->readSeq();
		   S_Cell.put(completionTime)<<Envp;
       	                if(((count++)%Nrm==0)||((count)%Nrm>Mrm&&(completionTime>=Trm+last_RM)))
		        {
if(debug)OUTPUT<<" count "<<count<<" NRM "<<Nrm<<" at "<<completionTime<<"\n";
	                 last_RM=completionTime;
			 LOG_NEW;
       			 ATMCell* RM_Cell = new ATMCell(0);
		         RM_Cell->setRM(1);
 			 RM_Cell->setSource(source);
			 RM_Cell->setDestination(destination);
			 RM_Cell->setVC(VC);
			 RM_Cell->setDIR(1);
			 RM_Cell->setACR(ACR);
			 RM_Cell->setER(PCR);
			 RM_Cell->setCI(0);	
			 Envelope envp( *RM_Cell);
			 S_Cell.put(completionTime)<<envp;
		        }
	       }
//****************************************************************************/
	      if(RM.dataNew)
	      {
		Envelope Envp;
                RM.get().getMessage(Envp);
                ATMCell* cellPtr =(ATMCell *)
                    Envp.myData();
		float ER;
		ER=cellPtr->readER();
		int CI=cellPtr->readCI();
if(debug)
{OUTPUT<<" RM "<<ER<<" DEST "<<cellPtr->readDestination()<<" VC "<<cellPtr->readVC()<<" at "<<completionTime<<"\n";
OUTPUT<<"\n CI "<<CI<<"  ER "<<ER<<" ADR "<<ADR<<" AIR "<<AIR<<"\n";}
		if(CI==0)
	        {
if(debug)
OUTPUT<<" DO MD "<<ACR<<" Nrm* "<<AIR;
			ACR+=(float)Nrm*(float)AIR;
if(debug)
OUTPUT<<" ACR "<<ACR<<"\n";
			ACR=min((float)ACR,(float)PCR);
if(debug)
OUTPUT<<" ACR,PCR "<<ACR<<" PCR "<<PCR;
		}
		else
		{
if(debug)
OUTPUT<<" DO AI "<<ACR<<" = "<<ACR<<" / "<<MDF;
	                ACR-=(float)Nrm*(float)((float)ACR/(float)mdf);
if(debug)
OUTPUT<<" ACR "<<ACR<<"\n";
		}		
		ACR=min((float)ACR,(float)ER);
		ACR=max((float)ACR,(float)MCR);
if(debug)
OUTPUT<<" ACRFinal= "<<ACR<<" at "<<completionTime<<"\n";
 	
              }

	   } // end go
} // end defstar
