defstar {
 	name { PRCA_Send}
	domain { DE }
	author { Dorgham Sisalem}
        copyright { SEE $PTOLEMY_SIMULATIONS/copyright }

	desc {
	}

	input { name {RM }
                type { message}
	        desc { Resource Management Cells}
	}
	input { name { Cell}
                type { message}
	        desc { Messages to send}
	}
	input { name { Size}
                type { int}
	        desc { Size of the queue}
	}

	output { name { S_Cell}
                 type { message}
	         desc { send a message}
        }
	output { name { demand}
                 type { float}
	         desc { Fetch a message from the queue}
        }

	defstate {
		name { ICR}
		type { float}
		default { 18278}
		desc { Initial Cell Rate}
	}
	defstate {
		name { AIR}
		type { float}
		default { 125}
		desc { Additive Increase Rate}
	}
	defstate {
		name { PCR}
		type { float}
		default { 365566}
		desc { Peak Cell Rate}
	}
	defstate {
		name { Nrm}
		type { int}
		default {32 }
		desc { RM Cell interval}
	}
	defstate {
		name { MCR}
		type { float}
		default { 3655.7}
		desc { Minimum Cell Rate}
	}
	defstate {
		name { MDF}
		type { float}
		default {8 }
		desc { Multiplicative Decrease Factor}
	}

	defstate {
		name { source}
		type { int}
		default {0 }
		desc { source address}
	}
	defstate {
		name { destination}
		type { int}
		default {0 }
		desc { destination address}
	}


	defstate {
		name { fileName }
		type { string }
		default { "<stdout>" }
		desc { Filename for output }
	}
	hinclude { "pt_fstream.h" ,<math.h>,"ATMCell.h",<minmax.h>}
	protected {
		pt_ofstream *p_out;
	}

	protected {
	            float ACR;
		    int count;
	            int cell_sent;
	            double mdf,ADR;
	            double next_cell_time;
		    int queue;
		  }

//*****************************************************************************/
// initialization: 
//*****************************************************************************/

	setup { 
	        ACR=ICR;
	        count=0;
	        cell_sent=0;
	        mdf=pow(2,MDF);
        	ADR=ACR/mdf;
	        next_cell_time=0;
		queue=1;
              }

//*****************************************************************************/
//*****************************************************************************/

	begin  {  
                LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
		}

//****************************************************************************/
// set scheduling priorities
//****************************************************************************/

	constructor { 
                      p_out = 0;
		      Size.before(Cell);
		      Size.before(RM);
		      RM.before(Cell);
               	    }
        wrapup {
	        LOG_DEL; delete p_out;
		p_out = 0;
		}
	destructor { LOG_DEL; delete p_out;}

	go {
                pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
	        if(Cell.dataNew)
	        {
		   Envelope Envp;
                   Cell.get().getMessage(Envp);
                   const ATMCell *cellPtr =(const ATMCell *)
                    Envp.myData();

	           if((ACR>ICR)||cell_sent)
	           {
	                ACR=max(ACR-ADR,MCR);
//OUTPUT<<" ACR "<<ACR;
		   }
		   if(queue)
	           {
			queue--;
			S_Cell.put(completionTime)<<Envp;
//OUTPUT<<" SEND at "<<completionTime;
			cell_sent=1;
		    }
		    else
			cell_sent=0;
		next_cell_time+=(float) 1/ACR; //Schedule Cell

	        demand.put(completionTime)<<(float) 1/ACR;
//OUTPUT<<" next "<<next_cell_time<<" \n";
	      }
	      if(RM.dataNew)
	      {
		Envelope Envp;
                RM.get().getMessage(Envp);
		ACR+=(Nrm*AIR)+((float)Nrm*(float)ADR);
OUTPUT<<" ACR+ "<<ACR<<" NRM*AIR "<<Nrm*AIR<<" Nrm*ADR "<<(float)Nrm*(float)ADR<<"\n";
			ACR=min((float)ACR,(float)PCR);
OUTPUT<<" ACR,PCR "<<ACR<<" PCR "<<PCR;
 	
		ADR=ACR/mdf;
              }
	      if(Size.dataNew)
	      {
		queue=Size.get();
	      }

	   } // end go
} // end defstar
