static const char file_id[] = "DErouter.pl";
// .cc file generated from DErouter.pl by ptlang
/*
 * copyright (c) SEE $PTOLEMY_SIMULATIONS/copyright
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DErouter.h"

const char *star_nm_DErouter = "DErouter";

const char* DErouter :: className() const {return star_nm_DErouter;}

ISA_FUNC(DErouter,DEStar);

Block* DErouter :: makeNew() const { LOG_NEW; return new DErouter;}

DErouter::DErouter ()
{
	setDescriptor("routes the incoming packest according to the routing table");
	addPort(INPUT.setPort("INPUT",this,MESSAGE));
	addPort(output0.setPort("output0",this,MESSAGE));
	addPort(output1.setPort("output1",this,MESSAGE));
	addPort(general.setPort("general",this,MESSAGE));
	addState(RoutingTable.setState("RoutingTable",this,"","routing map: address of directly connected hosts"));
	addState(Mode.setState("Mode",this,"1","1=VP routing else VC routing"));
	addState(fileName.setState("fileName",this,"<stdout>","Filename for output"));
	addState(debug.setState("debug",this,"0","Filename for output"));

# line 84 "DErouter.pl"
p_out = 0;
}

void DErouter::wrapup() {
# line 87 "DErouter.pl"
LOG_DEL; delete p_out;
		p_out = 0;
}

void DErouter::begin() {
# line 75 "DErouter.pl"
LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
}

DErouter::~DErouter() {
# line 90 "DErouter.pl"
LOG_DEL; delete p_out;
}

void DErouter::setup() {
# line 69 "DErouter.pl"
}

void DErouter::go() {
# line 94 "DErouter.pl"
pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
		InDEMPHIter inIter(INPUT);
		InDEPort* inPtr;
		while ((inPtr = inIter++) != 0) 
		{
			while (inPtr->dataNew) 
			{
				Envelope theEnvp;
				inPtr->get().getMessage(theEnvp);
				const ATMCell* cellPtr = (const ATMCell*)
						theEnvp.myData();
if(debug){
if(cellPtr->readCI())
OUTPUT<<" WHHHHY "<<cellPtr->readCI()<<"\n";}
			        int dest;
				if(Mode==1)
				   dest =cellPtr->readDestination();
				else
				   dest =cellPtr->readVC();
//OUTPUT<<"  DEST "<<dest;

				if(dest==RoutingTable[0]) 
				{
					output0.put(completionTime)<<theEnvp;
				}
				else
				{
					if(dest==RoutingTable[1])
					{
						output1.put(completionTime)<<theEnvp;
					}
					else
					{
						general.put(completionTime)<<theEnvp;
					}
				}
				inPtr->getSimulEvent();
			}
		}
}

// prototype instance for known block list
static DErouter proto;
static RegisterBlock registerBlock(proto,"router");
