#ifndef _DECAPAlgorithm_h
#define _DECAPAlgorithm_h 1
// header file generated from DECAPAlgorithm.pl by ptlang

#ifdef __GNUG__
#pragma interface
#endif

/*
 * copyright (c) SEE $PTOLEMY_SIMULATIONS/copyright
 */
#include "DEStar.h"
#include "ATMCell.h"
#include <math.h>
#include <minmax.h>
#include "pt_fstream.h"
#include "IntState.h"
#include "FloatState.h"
#include "StringState.h"
#include "IntArrayState.h"

class DECAPAlgorithm : public DEStar
{
public:
	DECAPAlgorithm();
	/* virtual */ Block* makeNew() const;
	/* virtual*/ const char* className() const;
	/* virtual*/ int isA(const char*) const;
	/* virtual */ void wrapup();
	/* virtual */ void begin();
	/* virtual */ ~DECAPAlgorithm();
	InDEPort IN_RM;
	MultiInDEPort RET_RM;
	InDEPort Congestion;
	OutDEPort OUT_RM;
	OutDEPort NEW_RM;

protected:
	/* virtual */ void setup();
	/* virtual */ void go();
	FloatState PCR;
	FloatState target_rate;
	FloatState Rup;
	FloatState ERU;
	FloatState Rdn;
	FloatState ERF;
	IntState DQT;
	IntState max_count;
	FloatState interval;
	IntState mode;
	IntArrayState RM_Proc;
	IntState debug;
	StringState fileName;
# line 122 "DECAPAlgorithm.pl"
pt_ofstream *p_out;
# line 126 "DECAPAlgorithm.pl"
int congested;
			float ACR,MACR;
			float start_time;
			int count;
			float ERS;

};
#endif
