defstar {
 	name { CellsToTCP_ECN }
	domain { DE }
	author { Bernd Deffner and Dorgham Sisalem }
	version { %W% %G% }
        copyright {See $PTOLEMY_SIMULATIONS/tcp/copyright
        }
	location {  }
	desc { This star receives ATMCells and rebuilds the TCPPacket.
          For misordered cell the sequence number of the TCPPacket 
          is sent to the lostPackets output. 
	}

	input { 
          name { input }
          type { message }
          desc { arriving cell }
        }

	input { 
          name { rm_input }
          type { message }
          desc { RM cell }
        }

	output { 
          name { output } 
          type { message }
          desc { complete TCPPacket }
        }

        output {
          name { lostPackets} 
          type { int }
          desc { sequence number of defective TCPPacket }
        }

	defstate {
		name { VC }
		type {int }
	        default{0}
	}
	hinclude { "ATMCell.h", "TCPPacket.h", <fstream.h> }
	defstate {
		name { fileName }
		type { string }
		default { "<stdout>" }
		desc { Filename for output }
	}
	hinclude { "pt_fstream.h" }
	protected {
		pt_ofstream *p_out;
	}


	protected { int outOfSequence;
                    int expected,received;
                    int numberOfCells,CI; 
        }
  
        setup { expected= 0;  // expected sequence number
                received= 0; // sequence number of last received cell
		CI=0;
              }
	begin{LOG_NEW; p_out = new pt_ofstream(fileName);
		}

        wrapup{if(p_out){LOG_DEL; delete p_out; p_out=NULL;}}

	destructor { if(p_out){LOG_DEL; delete p_out; p_out=NULL;}}
   	go {    completionTime= arrivalTime;
                pt_ofstream& OUTPUT = *p_out;
                outOfSequence= 0;

                // get cells

	    if(rm_input.dataNew)
	    {
	        Envelope inEnvlp;
                rm_input.get().getMessage(inEnvlp);
                ATMCell *Cell= (ATMCell*) inEnvlp.myData();
		if(!CI)
			CI=Cell->readCI();
	       //if(CI)OUTPUT<<" CI "<<CI<<" at "<<completionTime<<"\n";

	    }
	    if(input.dataNew)
	    {
                Envelope inEnvlp;
                input.get().getMessage(inEnvlp);
                ATMCell *Cell= (ATMCell*) inEnvlp.myData(); 

                TCPP * s= (TCPP *) Cell->cell; // use struct to retrieve header

                received= Cell->readSeq(); 

                if (received != expected )
	        {
                 //  some cell has gone lost
                  lostPackets.put(completionTime) << s->Seq;
                  expected= 0;                    //reset counter
                  outOfSequence= 1;
                }
	
                if (received==0)   //first cell of an AudioPacket arrived 
                {
                  expected= 1;
              
                  // how many cells make up this TCPPacket ?

                  numberOfCells= ( s->Size +
                    TCPPACKET_HEADERLENGTH)/48 +
                    ((s->Size + TCPPACKET_HEADERLENGTH)%48>0);
                }
                else               //cell has arrived in order
                  if (!outOfSequence) expected++;
	         

                if (received==numberOfCells-1 && !outOfSequence)

                     //TCPPacket complete
                {
                   TCPPacket* tcp= new TCPPacket( s->Seq);
	           tcp->setAck(s->Ack);
	           tcp->setWin(s->Win);
	           tcp->setSize(s->Size);
	           tcp->setNum(s->Num);
	           tcp->setVC(VC);
		   tcp->setECN(CI);
//if(CI)OUTPUT<<" TCP CI "<<tcp->readECN()<<" at "<<completionTime<<"\n";
		   CI=0;
	           tcp->setTimestamp(s->Timestamp);
                   Envelope outEnvlp (*tcp);
                   // output tcp packet
                   output.put(completionTime) << outEnvlp;
                   
                   expected= 0;                   // reset counter
                }
	    }
       
	} // end go
} // end defstar
