 defstar {
 	name {EPD_RED}
	domain { DE }
	author { Dorgham Sisalem}
        copyright { SEE $PTOLEMY_SIMULATIONS/copyright }

	desc {
	}


	input { name {in }
                type {message }
	}
	input { name {size }
                type {int }
	}

	output { name {overflow }
                 type {message }
        }
	output { name {out }
                 type {message }
        }

	defstate {
		name {Wg }
		type {float }
		default {0.002 }
		desc { queue weight}
	}

	defstate {
		name {Min }
		type {float }
		default {10 }
		desc { min threshold}
	}

	defstate {
		name {Max }
		type {float }
		default {100 }
		desc { max threshold}
	}

	defstate {
		name {MaxP }
		type {float }
		default {0.02 }
		desc { max threshold}
	}

	hinclude { "ATMCell.h" ,<math.h>,<Uniform.h>,"TCPPacket.h"}
	ccinclude{ <ACG.h> }
	protected{ Uniform *random;}
	code{ extern ACG* gen;}

	defstate {
		name { fileName }
		type { string }
		default { "<stdout>" }
		desc { Filename for output }
	}
	hinclude { "pt_fstream.h" }
	protected {
		pt_ofstream *p_out;
	}

	protected { 	float av; 
			int count;
			float C1,C2,Pb;
			double R;
			int DISCARD,Size,Destination;
			int i;
		  }

//*****************************************************************************/
// initialization: 
//*****************************************************************************/

	setup { av=0;
		count=-1;
		C1=MaxP/(Max-Min);
		C2=(MaxP*Min)/(Max-Min);
		DISCARD=0;
		i=0;
		Destination=-1;
              }

//*****************************************************************************/
//*****************************************************************************/

	begin  {  
                LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
		if(random) delete random;
		random=new Uniform(0,1,gen);
		}

//****************************************************************************/
// set scheduling priorities
//****************************************************************************/

	constructor { 
                      p_out = 0;
		      random = NULL;
               	    }
        wrapup {
	        LOG_DEL; delete p_out;
		p_out = 0;
		}
	destructor { LOG_DEL; delete p_out;}

	go {
                pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
		if(size.dataNew)
		{
	                int tmp=Size;
		   	Size=size.get();
		  	float temp=(float)Size-av; 
		   av=av+(float)((float)Wg*(float)temp);

if(Size>0)
OUTPUT<<" Size "<<Size<<" AVERAGE "<<av<<" at "<<completionTime<<"\n";
		}
		if(in.dataNew)
		{
                        Envelope theEnvp;
                        in.get().getMessage(theEnvp);
			const ATMCell* cellPtr=(const ATMCell *) 
		               theEnvp.myData();
			long int seq=cellPtr->readSeq();
			int current_dest=cellPtr->readDestination();

             TCPP * s= (TCPP *) cellPtr->cell; // use struct to retrieve header
			if(DISCARD==1)
			{
				if(seq>0)
				{
                        	        out.put(completionTime)<<theEnvp;
					return;
				}
				DISCARD=2;
				Destination=current_dest;
OUTPUT<<" DISCARD "<<s->Seq<<" seq "<<seq<<" Size "<<Size<<" Destination "<<cellPtr->readDestination()<<" VC "<<cellPtr->readVC()<<" at "<<completionTime<<"\n";	                        overflow.put(completionTime)<<theEnvp;
				return;
		
			}
			if((DISCARD==2)&&(Destination==current_dest))
			{
				if(seq==0)
				{
					Destination=-1;
					DISCARD=0;
                             	        out.put(completionTime)<<theEnvp;
					return;
				}

OUTPUT<<" DISCARD=2 "<<s->Seq<<" seq "<<seq<<" Size "<<Size<<" Destination "<<cellPtr->readDestination()<<" VC "<<cellPtr->readVC()<<" at "<<completionTime<<"\n";	                        overflow.put(completionTime)<<theEnvp;
				return;
			}
		        if(DISCARD==3)
		        {
		                if(seq>0)
			        {
			          overflow.put(completionTime)<<theEnvp;
				  return;
			        }
			        DISCARD=0;
				Destination=cellPtr->readDestination();
OUTPUT<<" DISCARD "<<s->Seq<<" seq "<<seq<<" Size "<<Size<<" Destination "<<cellPtr->readDestination()<<" VC "<<cellPtr->readVC()<<" at "<<completionTime<<"\n";
		        }
			if(((int)Min<=(int)av)&&((int)Max>(int)av))
			{
		             if((seq==0)&&(Destination<0))
		             {   
			        count++;
				if(count==0)
					R=(*random)();
				Pb=(C1*av)-C2;
	                        if((count>0)&&(count>=(R/Pb)))
				{
					DISCARD=1;
					count=0;
					if(seq==0)
	                                {
				         Destination=current_dest;
				         DISCARD=2;
				         overflow.put(completionTime)<<theEnvp;
					 return;
					}
				}
if(Pb)
OUTPUT<<" AV "<<av<<" Count "<<count<<" MAX "<<Max<<" R/Pb "<<R/Pb<<" at "<<completionTime<<"\n";
	                     }
	                     out.put(completionTime)<<theEnvp;
			}
			else
			{
				count=-1;
				if((int)Max<=(int)av)
				{
					count=-1;
			                overflow.put(completionTime)<<theEnvp;
					return;
				}
	                        out.put(completionTime)<<theEnvp;
			}

		}


	   } // end go
} // end defstar
