static const char file_id[] = "DEMITAlgorithm.pl";
// .cc file generated from DEMITAlgorithm.pl by ptlang
/*
 * copyright (c) SEE $PTOLEMY_SIMULATIONS/copyright
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEMITAlgorithm.h"

const char *star_nm_DEMITAlgorithm = "DEMITAlgorithm";

const char* DEMITAlgorithm :: className() const {return star_nm_DEMITAlgorithm;}

ISA_FUNC(DEMITAlgorithm,DEStar);

Block* DEMITAlgorithm :: makeNew() const { LOG_NEW; return new DEMITAlgorithm;}

DEMITAlgorithm::DEMITAlgorithm ()
{
	setDescriptor("This tart simulates the behaviour of the MIT allocation scheme as\nwas proposed by Kalampokas, Varma and Ramakrishnan");
	addPort(IN_RM.setPort("IN_RM",this,MESSAGE));
	addPort(RET_RM.setPort("RET_RM",this,MESSAGE));
	addPort(OUT_RM.setPort("OUT_RM",this,MESSAGE));
	addPort(NEW_RM.setPort("NEW_RM",this,MESSAGE));
	addState(Number_VC.setState("Number_VC",this,"9","Number of possible VCs"));
	addState(Rate.setState("Rate",this,"Rate","Rate"));
	addState(RM_Proc.setState("RM_Proc",this,"","RM_Proc"));
	addState(mode.setState("mode",this,"0","0=Explicit rate Notification 1=Intelligent Marking"));
	addState(fileName.setState("fileName",this,"<stdout>","Filename for output"));
	addState(debug.setState("debug",this,"0","debug"));

# line 118 "DEMITAlgorithm.pl"
p_out = 0;
}

void DEMITAlgorithm::wrapup() {
# line 121 "DEMITAlgorithm.pl"
LOG_DEL; delete p_out;
		p_out = 0;
}

void DEMITAlgorithm::begin() {
# line 109 "DEMITAlgorithm.pl"
LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
}

DEMITAlgorithm::~DEMITAlgorithm() {
# line 124 "DEMITAlgorithm.pl"
LOG_DEL; delete p_out;
}

void DEMITAlgorithm::setup() {
# line 90 "DEMITAlgorithm.pl"
for(int i=0;i<12;i++)
		{
			VC_info[i].Cell_Seen=BOTTLED; //In this scheme this flag idicates mode
			VC_info[i].Rev_RM_Seen=0;
			VC_info[i].Last_ER=0;
			VC_info[i].Last_ACR=0;
		}
		Bf=Rate;
		BottledN=0;
		MaxER=0;
		maxI=0;
		Requested=0;
		Rmax=0;
}

void DEMITAlgorithm::go() {
# line 127 "DEMITAlgorithm.pl"
pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
		InDEMPHIter inIter(RET_RM);
		InDEPort* inPtr;

//**************************************************************************

		if(IN_RM.dataNew)
	        {
			Envelope Envp;
	                IN_RM.get().getMessage(Envp);
       	            	ATMCell* cellPtr=(ATMCell *)
                    	  	Envp.myData();
			int VP=cellPtr->readDestination();
			int VC =cellPtr->readVC();
			int index;
			int VPs=(int)Number_VC/3;
			for(int l=0;l<VPs;l++)
		        {
		            if(VP==RM_Proc[l])
			           index=l;
	                }
		        index=(index*3)+(VC%3);
				
			
                  	if(cellPtr->readRM()==0)
			{
			        OUT_RM.put(completionTime)<<Envp;
				return;
			}
//*********************
//Here Rev_RM_Seen signals if the connection has sent any data yet, if not
//then initializations are done.
//********************
                        if(VC_info[index].Rev_RM_Seen==0)
                        {
                                VC_info[index].Rev_RM_Seen=1;
                                BottledN++;
OUTPUT<<" &&& ";
                                int count=0;
                                for(int k=0;k<Number_VC;k++)
                                        if(VC_info[k].Rev_RM_Seen)
                                                count++;
                                Rfair=Rate/count;
OUTPUT<<" Rfair "<<Rfair<<" Bottle "<<BottledN;
                        }
 

			float ACR=cellPtr->readACR();
			float ER=cellPtr->readER();
OUTPUT<<" MaxER "<<MaxER<<" mI "<<maxI<<" ACR "<<ACR;
			if((int)MaxER<(int)ACR)
			{
				MaxER=ACR;
				maxI=index;
				if(VC_info[index].Cell_Seen==SATISFIED)
				{
					VC_info[index].Cell_Seen=BOTTLED;
					BottledN++;
OUTPUT<<" &&&1 ";
				}
			}
			else
			{
				if((int)MaxER>(int)ACR)
					if(maxI==index)
						MaxER=ACR;
			}
			Requested+=ER-VC_info[index].Last_ER;
			VC_info[index].Last_ER=ER;
			float temp;
			if((int)Requested>(int)Rate)
			{
				if(VC_info[index].Cell_Seen==SATISFIED)
					temp=BottledN+1;
				else
					temp=BottledN;
				Rmax=(float)Rfair+((float)
				(Bf+VC_info[index].Last_ACR-Rfair)/(float)temp);
	OUTPUT<<" BN "<<temp<<" fair "<<Rfair<<" Rmax "<<Rmax;
				if((int)Rmax<(int)Rfair)
					Rmax=Rfair;
				if((int)ER<=(int)Rmax)
				{
					Rmax=ER;
					if(maxI!=index)
					{
				           if(VC_info[index].Cell_Seen==BOTTLED)
					   {
						VC_info[index].Cell_Seen=
							SATISFIED;
						BottledN--;
OUTPUT<<" #### ";
					   }
					}
				}
				else
				{
					if(VC_info[index].Cell_Seen==SATISFIED)
					{
						VC_info[index].Cell_Seen=
							 	BOTTLED;
						BottledN++;
OUTPUT<<" &&&2 ";
					}
				}
		
			}
			else					
			{
				if(VC_info[index].Cell_Seen==BOTTLED)
				{
					VC_info[index].Cell_Seen=SATISFIED;
					BottledN--;
OUTPUT<<" ###1 ";
					Rmax=ER;
				}
			}
			if(((int)Rmax>ACR)&&((int)ACR>0))
			{
				if(maxI!=index)
					if(VC_info[index].Cell_Seen==BOTTLED)
					{
						VC_info[index].Cell_Seen=
								SATISFIED;
						BottledN--;
OUTPUT<<" ###2 ";
					}
			}
			if(VC_info[index].Cell_Seen==BOTTLED)
				ACR=Rfair;

OUTPUT<<"\n BF "<<Bf<<" LACR "<<VC_info[index].Last_ACR<<" ACR "<<ACR;
			Bf+=VC_info[index].Last_ACR-ACR;
		        VC_info[index].Last_ACR=ACR;	
OUTPUT<<" LACR "<<VC_info[index].Last_ACR<<" Rmax "<<Rmax<<" ACR "<<ACR;
						
                        LOG_NEW;
                        ATMCell* RM_Cell = new ATMCell(0);
                        RM_Cell->setRM(1);
                        RM_Cell->setSource(cellPtr->readSource());
                        RM_Cell->setVC(cellPtr->readVC());
                        RM_Cell->setDestination(cellPtr->readDestination());
                        RM_Cell->setDIR(0);
                        RM_Cell->setCI(cellPtr->readCI());
                        RM_Cell->setACR(cellPtr->readACR());
			if(Rmax<ER)
				ER=Rmax;
			RM_Cell->setER(ER);
			Envelope envp(*RM_Cell);
			OUT_RM.put(completionTime)<<envp;
if(debug)
OUTPUT<<" DEST "<<VP<<" VC "<<VC<<" ACR= "<<ACR<<" ER "<<RM_Cell->readER()<<" at "<<completionTime<<"\n";
		}
//**************************************************************************
		while ((inPtr = inIter++) != 0) 
		{
		     while (inPtr->dataNew) 
		     {
			Envelope Envp;
			inPtr->get().getMessage(Envp);
       	            	ATMCell* cellPtr=(ATMCell *)
                    	  	Envp.myData();
OUTPUT<<" RECEIVE RM "<<cellPtr->readER()<<" DEST "<<cellPtr->readDestination()<<" VC "<<cellPtr->readVC()<<"\n";

			NEW_RM.put(completionTime)<<Envp;
		        return;
		    }
		}
}

// prototype instance for known block list
static DEMITAlgorithm proto;
static RegisterBlock registerBlock(proto,"MITAlgorithm");
