defstar {
 	name {MITAlgorithm }
	domain { DE }
	author { Dorgham Sisalem}
        copyright { SEE $PTOLEMY_SIMULATIONS/copyright }

	desc {This tart simulates the behaviour of the MIT allocation scheme as
was proposed by Kalampokas, Varma and Ramakrishnan
	}
	input { name { IN_RM}
                type { message}
	        desc { incoming RM Cells}
	}

	inmulti { name { RET_RM}
                type { message}
	        desc { Returning RM Cells}
	}


	output { name { OUT_RM}
                 type { message}
	         desc { Send RM Cells to the Destination}
        }

	output { name { NEW_RM}
                 type { message}
	         desc { updated RM Cells}
	}
        defstate {
                name {Number_VC }
                type { int}
                default { 9}
                desc {Number of possible VCs}
        }

        defstate {
		name {Rate}
                type { float}
                default { Rate}
                desc {Rate}
        }

        defstate {
                name { RM_Proc}
                type { intarray}
        }
        defstate {
                name { mode}
		type  { int }
                default { 0 }
	        desc{ 0=Explicit rate Notification 1=Intelligent Marking}
        }


	hinclude { "./VC.h","ATMCell.h" ,<math.h>,<minmax.h>}

	defstate {
		name { fileName }
		type { string }
		default { "<stdout>" }
		desc { Filename for output }
	}
        defstate {
                name { debug }
                type { int }
                default { 0 }
        }

	hinclude { "pt_fstream.h" }
	protected {
		pt_ofstream *p_out;
	}

	protected { VC_Data VC_info[12];
		    float fair_share,New_ER;
		    float Bf,MaxER,Requested;
		    int BottledN,maxI;
		    const int SATISFIED=1;
		    const int BOTTLED=0;
		    float Rmax,Rfair;

		  }

//*****************************************************************************/
// initialization: 
//*****************************************************************************/

	setup { 
		for(int i=0;i<12;i++)
		{
			VC_info[i].Cell_Seen=BOTTLED; //In this scheme this flag idicates mode
			VC_info[i].Rev_RM_Seen=0;
			VC_info[i].Last_ER=0;
			VC_info[i].Last_ACR=0;
		}
		Bf=Rate;
		BottledN=0;
		MaxER=0;
		maxI=0;
		Requested=0;
		Rmax=0;
              }

//*****************************************************************************/
//*****************************************************************************/

	begin  {  
                LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
		}

//****************************************************************************/
// set scheduling priorities
//****************************************************************************/

	constructor { 
                      p_out = 0;
               	    }
        wrapup {
	        LOG_DEL; delete p_out;
		p_out = 0;
		}
	destructor { LOG_DEL; delete p_out;}

	go {
                pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
		InDEMPHIter inIter(RET_RM);
		InDEPort* inPtr;

//**************************************************************************

		if(IN_RM.dataNew)
	        {
			Envelope Envp;
	                IN_RM.get().getMessage(Envp);
       	            	ATMCell* cellPtr=(ATMCell *)
                    	  	Envp.myData();
			int VP=cellPtr->readDestination();
			int VC =cellPtr->readVC();
			int index;
			int VPs=(int)Number_VC/3;
			for(int l=0;l<VPs;l++)
		        {
		            if(VP==RM_Proc[l])
			           index=l;
	                }
		        index=(index*3)+(VC%3);
				
			
                  	if(cellPtr->readRM()==0)
			{
			        OUT_RM.put(completionTime)<<Envp;
				return;
			}
//*********************
//Here Rev_RM_Seen signals if the connection has sent any data yet, if not
//then initializations are done.
//********************
                        if(VC_info[index].Rev_RM_Seen==0)
                        {
                                VC_info[index].Rev_RM_Seen=1;
                                BottledN++;
OUTPUT<<" &&& ";
                                int count=0;
                                for(int k=0;k<Number_VC;k++)
                                        if(VC_info[k].Rev_RM_Seen)
                                                count++;
                                Rfair=Rate/count;
OUTPUT<<" Rfair "<<Rfair<<" Bottle "<<BottledN;
                        }
 

			float ACR=cellPtr->readACR();
			float ER=cellPtr->readER();
OUTPUT<<" MaxER "<<MaxER<<" mI "<<maxI<<" ACR "<<ACR;
			if((int)MaxER<(int)ACR)
			{
				MaxER=ACR;
				maxI=index;
				if(VC_info[index].Cell_Seen==SATISFIED)
				{
					VC_info[index].Cell_Seen=BOTTLED;
					BottledN++;
OUTPUT<<" &&&1 ";
				}
			}
			else
			{
				if((int)MaxER>(int)ACR)
					if(maxI==index)
						MaxER=ACR;
			}
			Requested+=ER-VC_info[index].Last_ER;
			VC_info[index].Last_ER=ER;
			float temp;
			if((int)Requested>(int)Rate)
			{
				if(VC_info[index].Cell_Seen==SATISFIED)
					temp=BottledN+1;
				else
					temp=BottledN;
				Rmax=(float)Rfair+((float)
				(Bf+VC_info[index].Last_ACR-Rfair)/(float)temp);
	OUTPUT<<" BN "<<temp<<" fair "<<Rfair<<" Rmax "<<Rmax;
				if((int)Rmax<(int)Rfair)
					Rmax=Rfair;
				if((int)ER<=(int)Rmax)
				{
					Rmax=ER;
					if(maxI!=index)
					{
				           if(VC_info[index].Cell_Seen==BOTTLED)
					   {
						VC_info[index].Cell_Seen=
							SATISFIED;
						BottledN--;
OUTPUT<<" #### ";
					   }
					}
				}
				else
				{
					if(VC_info[index].Cell_Seen==SATISFIED)
					{
						VC_info[index].Cell_Seen=
							 	BOTTLED;
						BottledN++;
OUTPUT<<" &&&2 ";
					}
				}
		
			}
			else					
			{
				if(VC_info[index].Cell_Seen==BOTTLED)
				{
					VC_info[index].Cell_Seen=SATISFIED;
					BottledN--;
OUTPUT<<" ###1 ";
					Rmax=ER;
				}
			}
			if(((int)Rmax>ACR)&&((int)ACR>0))
			{
				if(maxI!=index)
					if(VC_info[index].Cell_Seen==BOTTLED)
					{
						VC_info[index].Cell_Seen=
								SATISFIED;
						BottledN--;
OUTPUT<<" ###2 ";
					}
			}
			if(VC_info[index].Cell_Seen==BOTTLED)
				ACR=Rfair;

OUTPUT<<"\n BF "<<Bf<<" LACR "<<VC_info[index].Last_ACR<<" ACR "<<ACR;
			Bf+=VC_info[index].Last_ACR-ACR;
		        VC_info[index].Last_ACR=ACR;	
OUTPUT<<" LACR "<<VC_info[index].Last_ACR<<" Rmax "<<Rmax<<" ACR "<<ACR;
						
                        LOG_NEW;
                        ATMCell* RM_Cell = new ATMCell(0);
                        RM_Cell->setRM(1);
                        RM_Cell->setSource(cellPtr->readSource());
                        RM_Cell->setVC(cellPtr->readVC());
                        RM_Cell->setDestination(cellPtr->readDestination());
                        RM_Cell->setDIR(0);
                        RM_Cell->setCI(cellPtr->readCI());
                        RM_Cell->setACR(cellPtr->readACR());
			if(Rmax<ER)
				ER=Rmax;
			RM_Cell->setER(ER);
			Envelope envp(*RM_Cell);
			OUT_RM.put(completionTime)<<envp;
if(debug)
OUTPUT<<" DEST "<<VP<<" VC "<<VC<<" ACR= "<<ACR<<" ER "<<RM_Cell->readER()<<" at "<<completionTime<<"\n";
		}
//**************************************************************************
		while ((inPtr = inIter++) != 0) 
		{
		     while (inPtr->dataNew) 
		     {
			Envelope Envp;
			inPtr->get().getMessage(Envp);
       	            	ATMCell* cellPtr=(ATMCell *)
                    	  	Envp.myData();
OUTPUT<<" RECEIVE RM "<<cellPtr->readER()<<" DEST "<<cellPtr->readDestination()<<" VC "<<cellPtr->readVC()<<"\n";

			NEW_RM.put(completionTime)<<Envp;
		        return;
		    }
		}
	   } // end go
} // end defstar
