 defstar {
 	name {RED}
	domain { DE }
	author { Dorgham Sisalem}
        copyright { SEE $PTOLEMY_SIMULATIONS/copyright }

	desc {This star simulates the random early packet drop scheme. The 
avarage queue length is calculated as an exponential weigthed moving
avaerage. Is the avergae between a Min and a Max threshold then packets
are dropped with a probability b. Is the averge larger than the maximum 
threshold then all arriving packets must be dropped.
	}

	input { name {size }
                type {int }
	}

	input { name {in }
                type {message }
	}

	output { name {out }
                 type {message }
        }
	output { name {overflow }
                 type {message }
        }

	defstate {
		name {Wg }
		type {float }
		default {0.002 }
		desc { queue weight}
	}

	defstate {
		name {Min }
		type {float }
		default {10 }
		desc { min threshold}
	}

	defstate {
		name {Max }
		type {float }
		default {100 }
		desc { max threshold}
	}

	defstate {
		name {MaxP }
		type {float }
		default {0.02 }
		desc { max threshold}
	}


	hinclude { "ATMCell.h" ,<math.h>,<Uniform.h>}
	ccinclude{ <ACG.h> }
	protected{ Uniform *random;}
	code{ extern ACG* gen;}

	defstate {
		name { fileName }
		type { string }
		default { "<stdout>" }
		desc { Filename for output }
	}
	hinclude { "pt_fstream.h" }
	protected {
		pt_ofstream *p_out;
	}

	protected { 	float av; 
			int count;
			float C1,C2,Pb;
			double R;
			//int Size;
		  }

//*****************************************************************************/
// initialization: 
//*****************************************************************************/

	setup { av=0;
	        count=-1;
		C1=MaxP/(Max-Min);
		C2=(MaxP*Min)/(Max-Min);
              }

//*****************************************************************************/
//*****************************************************************************/

	begin  {  
                LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
		if(random) delete random;
		random=new Uniform(0,1,gen);
		}

//****************************************************************************/
// set scheduling priorities
//****************************************************************************/

	constructor { 
                      p_out = 0;
		      random = NULL;
		      
               	    }
        wrapup {
	        LOG_DEL; delete p_out;
		p_out = 0;
		}
	destructor { LOG_DEL; delete p_out;}

	go {
                pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
//**********************************************************
//  Update the queue length average 
//**********************************************************
		if(size.dataNew)
		{
		   	int Size=size.get();
		  	float temp=(float)Size-av; 
		   av=av+(float)((float)Wg*(float)temp);
if(Size)
OUTPUT<<"  SIZE "<<Size<<" AVERAGE "<<av<<"\n";
		}
//*********************************************************
//  receive new data
//*********************************************************
		if(in.dataNew)
		{
                        Envelope theEnvp;
                        in.get().getMessage(theEnvp);
		if((Min<=av)&&(Max>av))// average between Min and Max
			{
                                count++;
				if(count==0)
					R=(*random)();
				Pb=(C1*av)-C2;
	                        if((count>0)&&(count>=(R/Pb)))
				{
					count=0;
	                                overflow.put(completionTime)<<theEnvp;
					return;
				}
OUTPUT<<" AV "<<av<<" Count "<<count<<" MAX "<<Max<<" R/Pb "<<R/Pb<<" at "<<completionTime<<"\n";
	                        out.put(completionTime)<<theEnvp;
			}
			else
			{
				 count=-1;
				if(Max<=av)
				{
			                count=-1;		
	                                overflow.put(completionTime)<<theEnvp;
					return;
				}
	                        out.put(completionTime)<<theEnvp;
			}

		}


	   } // end go
} // end defstar
