 defstar {
 	name {RED }
	domain { DE }
	author { Dorgham Sisalem}
        copyright { SEE $PTOLEMY_SIMULATIONS/copyright }

	desc {
	}

	input { name {size }
                type {int }
	}

	input { name {in }
                type {message }
	}

	output { name {out }
                 type {message }
        }
	output { name {overflow }
                 type {message }
        }

	defstate {
		name {Wg }
		type {float }
		default {0.002 }
		desc { queue weight}
	}

	defstate {
		name {Min }
		type {float }
		default {10 }
		desc { min threshold}
	}

	defstate {
		name {Max }
		type {float }
		default {100 }
		desc { max threshold}
	}

	defstate {
		name {MaxP }
		type {float }
		default {0.02 }
		desc { max threshold}
	}
	defstate {
		name {mode }
		type {int }
		default {1 }
		desc { 1=tcp 0=atm}
	}


	hinclude { "ATMCell.h" ,<math.h>,<Uniform.h>}
	ccinclude{ <ACG.h> }
	protected{ Uniform *random;}
	code{ extern ACG* gen;}

	defstate {
		name { fileName }
		type { string }
		default { "<stdout>" }
		desc { Filename for output }
	}
	hinclude { "pt_fstream.h" }
	protected {
		pt_ofstream *p_out;
	}

	protected { 	float av; 
			int count;
			float C1,C2,Pb;
			double R;
			//int Size;
		  }

//*****************************************************************************/
// initialization: 
//*****************************************************************************/

	setup { av=0;
	        if(mode==1)
		     count=-10;
		else
	             count=-1;
		C1=MaxP/(Max-Min);
		C2=(MaxP*Min)/(Max-Min);
              }

//*****************************************************************************/
//*****************************************************************************/

	begin  {  
                LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
		if(random) delete random;
		random=new Uniform(0,1,gen);
		}

//****************************************************************************/
// set scheduling priorities
//****************************************************************************/

	constructor { 
                      p_out = 0;
		      random = NULL;
		      
               	    }
        wrapup {
	        LOG_DEL; delete p_out;
		p_out = 0;
		}
	destructor { LOG_DEL; delete p_out;}

	go {
                pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
		if(size.dataNew)
		{
		   	int Size=size.get();
                        if(mode==1)
 			       Size=Size*10;
		  	float temp=(float)Size-av; 
		   av=av+(float)((float)Wg*(float)temp);
//OUTPUT<<" Size "<<Size<<" AVERAGE "<<av<<"\n";
		}
		if(in.dataNew)
		{
                        Envelope theEnvp;
                        in.get().getMessage(theEnvp);
//OUTPUT<<"  av "<<av<<" Pb "<<Pb<<" count "<<count<<" R/Pb "<<R/Pb <<" RAND "<<R<<"\n";				
		if((Min<=av)&&(Max>av))
			{
		                if(mode==1)
			            count+=10;
                                else
			             count++;
				if(count==0)
					R=(*random)();
				Pb=(C1*av)-C2;
	                        if((count>0)&&(count>=(R/Pb)))
				{
					count=0;
	                                overflow.put(completionTime)<<theEnvp;
					return;
				}
	                        out.put(completionTime)<<theEnvp;
			}
			else
			{
		                if(mode==1)
			            count=-10;
                                else
			             count=-1;
				if(Max<=av)
				{
			            if(mode==1)
			                count=-10;
                                    else
			                count=-1;
		
	                                overflow.put(completionTime)<<theEnvp;
					return;
				}
	                        out.put(completionTime)<<theEnvp;
			}

		}


	   } // end go
} // end defstar
