 defstar {
 	name {Sleep }
	domain { DE }
	author { Dorgham Sisalem}
        copyright { SEE $PTOLEMY_SIMULATIONS/copyright }

	desc {
	}

	input { name {demand }
                type {anytype }
	        desc {send another packet}
	}
	input { name {sleep }
                type {anytype }
	        desc {sleep or not to sleep? that is the question}
	}

	output { name {send_another }
                 type {int }
        }

	defstate {
		name { sb_hiwa}
		type { int}
		default { 1}
		desc { socket send queue high water mark}
	}
	defstate {
		name { sb_lowa}
		type { int}
		default { 1}
		desc { socket send queue low water mark}
	}
	hinclude { "TCPPacket.h" ,<math.h>}

	defstate {
		name { fileName }
		type { string }
		default { "<stdout>" }
		desc { Filename for output }
	}
	hinclude { "pt_fstream.h" }
	protected {
		pt_ofstream *p_out;
	}

	protected {int awake, control;
	           long int num,last_ack;
		  }

//*****************************************************************************/
// initialization: 
//*****************************************************************************/

	setup { 
			awake=1;
			control=1;
              }

//*****************************************************************************/
//*****************************************************************************/

	begin  {  
                LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
		}

//****************************************************************************/
// set scheduling priorities
//****************************************************************************/

	constructor { 
                      p_out = 0;
		      sleep.before(demand);
               	    }
        wrapup {
	        LOG_DEL; delete p_out;
		p_out = 0;
		}
	destructor { LOG_DEL; delete p_out;}

	go {
                pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
		if(demand.dataNew)
		{
//OUTPUT<<" demand0 "<<awake<<"\n";
			demand.dataNew=FALSE;		
			if(awake<sb_hiwa)
			{
				send_another.put(completionTime)<<1;
				control=1;
//OUTPUT<<" demand "<<awake<<"\n";
			}
			else
				control=0;
		}
		if(sleep.dataNew)
		{
		        Envelope Envp;
		        sleep.get().getMessage(Envp);
		        const TCPPacket* packetPtr=(const TCPPacket *)
		        Envp.myData();
		        long int Ack=packetPtr->readAck();
			int seq=packetPtr->readSeq();
			if(Ack==-1)
		        {
		           num=packetPtr->readNum();
			}
		        else
		            last_ack=Ack;
			awake=num-last_ack;
//OUTPUT<<" demand3 "<<awake<<" ACK "<<Ack<<" num "<<num<<" SEQ "<<seq<<" Last //"<<last_ack<<" at "<<completionTime<<"\n";
			if(awake<sb_hiwa)
			{
				if(!control)
			        {
					send_another.put(completionTime)<<1;
				        control=0;
//OUTPUT<<" demand1 "<<awake<<"\n";
	                        }
			
			}
		}
	   } // end go
} // end defstar
