 defstar {
 	name {TCP_Router }
	domain { DE }
	author { Dorgham Sisalem}
        copyright { SEE $PTOLEMY_SIMULATIONS/copyright }

	desc {This star simulates a simple router that can accept three
connections in its input and routes these connections to three different
outputs. The routing is done according to the routing table.
	}

	inmulti { name {INPUT }
                type {message }
	        desc {first input }
	}

	output { name {output0 }
                 type {message }
	         desc {first output}
        }

	output { name { output1}
                 type { message}
	         desc { second output }
        }

	output { name { general}
                 type { message}
	         desc { general output}
        }

	defstate {
		name { RoutingTable}
		type { intarray}
		desc { routing map: address of directly connected hosts}
	}
	defstate {
		name { Mode}
		type { int}
	        default{1}
		desc { 1=VP routing; else VC routing}
	}

	hinclude { "TCPPacket.h" ,<math.h>}

	defstate {
		name { fileName }
		type { string }
		default { "<stdout>" }
		desc { Filename for output }
	}
	hinclude { "pt_fstream.h" }
	protected {
		pt_ofstream *p_out;
	}

	protected { 
		  }

//*****************************************************************************/
// initialization: 
//*****************************************************************************/

	setup { 
              }

//*****************************************************************************/
//*****************************************************************************/

	begin  {  
                LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
		}

//****************************************************************************/
// set scheduling priorities
//****************************************************************************/

	constructor { 
                      p_out = 0;
               	    }
        wrapup {
 	        LOG_DEL; delete p_out;
		p_out = 0;
		}
	destructor { LOG_DEL; delete p_out;}

	go {
                pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
		InDEMPHIter inIter(INPUT);
		InDEPort* inPtr;
		while ((inPtr = inIter++) != 0) 
		{
			while (inPtr->dataNew) 
			{
				Envelope theEnvp;
				inPtr->get().getMessage(theEnvp);
				const TCPPacket* cellPtr = (const TCPPacket*)
						(&theEnvp)->myData();
				int dest;
				if(Mode==1)
			             dest=cellPtr->readDestination();
				else
			             dest=cellPtr->readVC(); 
				if(dest==RoutingTable[0]) 
				{
					output0.put(completionTime)<<theEnvp;
				}
				else
				{
					if(dest==RoutingTable[1])
					{
					  output1.put(completionTime)<<theEnvp;
					}
					else
					{
				          general.put(completionTime)<<theEnvp;
					}
				}
				inPtr->getSimulEvent();
			}
		}	
	   } // end go
} // end defstar

